package com.hai.goods.service.impl;

import com.hai.dao.GoodsDetailMapper;
import com.hai.dao.GoodsLogisticsMapper;
import com.hai.entity.ApiMerchantsExample;
import com.hai.entity.GoodsDetail;
import com.hai.entity.GoodsDetailExample;
import com.hai.entity.GoodsLogistics;
import com.hai.goods.service.GoodsDetailService;
import org.apache.commons.collections4.MapUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;


@Service("goodsDetailService")
public class GoodsDetailServiceImpl implements GoodsDetailService {

    @Resource
    private GoodsDetailMapper goodsDetailMapper;

    @Override
    public void insertGoodsDetail(GoodsDetail goodsDetail) {
        goodsDetailMapper.insert(goodsDetail);
    }

    @Override
    public void updateGoodsDetail(GoodsDetail goodsDetail) {
        goodsDetailMapper.updateByPrimaryKey(goodsDetail);
    }

    @Override
    public List<GoodsDetail> getGoodsDetailList(Map<String, Object> map) {

        GoodsDetailExample example = new GoodsDetailExample();
        GoodsDetailExample.Criteria criteria = example.createCriteria();

        if (MapUtils.getString(map, "title") != null) {
            criteria.andNameLike("%" +  MapUtils.getString(map, "title") + "%");
        }
        if (MapUtils.getString(map, "goodsLabel") != null) {
            criteria.andGoodsLabelLike("%" +  MapUtils.getString(map, "goodsLabel") + "%");
        }
        if (MapUtils.getLong(map, "goodsType") != null) {
            criteria.andGoodsTypeEqualTo(MapUtils.getLong(map, "goodsType") );
        }
        if (MapUtils.getLong(map, "opId") != null) {
            criteria.andOpIdEqualTo(MapUtils.getLong(map, "opId") );
        }
        if (MapUtils.getLong(map, "companyId") != null) {
            criteria.andCompanyIdEqualTo(MapUtils.getLong(map, "companyId") );
        }
        if (MapUtils.getInteger(map, "status") != null) {
            criteria.andStatusEqualTo(MapUtils.getInteger(map, "status") );
        } else {
            criteria.andStatusNotEqualTo(0);
        }

        example.setOrderByClause("create_time desc");
        return goodsDetailMapper.selectByExample(example);
    }

    @Override
    public GoodsDetail findGoodsDetailById(Long id) {
        return goodsDetailMapper.selectByPrimaryKey(id);
    }

}
